/**
 * File: defines.h
 * Created on: 22 feb 2015 г.
 * Description:
 * PhotoPizza DIY is an open source project of 360° product photography turntable.
 *
 * Author: Roman Savrulin <romeo.deepmind@gmail.com>
 * Project Author: Vladimir Matiyasevith <vladimir.m@makerdrive.com>
 * Project Site: PhotoPizza.org
 *
 * Copyright: 2015 MakerDrive
 * Copying permission statement:
 *  This file is part of PhotoPizza DIY.
 *
 *  PhotoPizza DIY is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef defines_h
#define defines_h

#define VERSION "V. 2.1.2"

//#define DBG(x) Serial.println((String)x);

#define BOARD_TYPE_NANO 0
#define BOARD_TYPE_UNO 1

#define BOARD_TYPE BOARD_TYPE_NANO

#ifndef BOARD_TYPE
#define BOARD_TYPE BOARD_TYPE_UNO
#endif

#if (BOARD_TYPE == BOARD_TYPE_NANO)
#define MOTOR_STP_PIN 12
#define MOTOR_DIR_PIN 13
#define RELAY_PIN_A   3
#define RELAY_PIN_B   4 
#define RELAY_PIN_C   5
#elif (BOARD_TYPE == BOARD_TYPE_UNO)
#define MOTOR_STP_PIN 12
#define MOTOR_DIR_PIN 13
#define RELAY_PIN_A   3
#define RELAY_PIN_B   4
#define RELAY_PIN_C   5
#else
#error "Board Not Supported!"
#endif


#define RELAY_HOLD_TIMEOUT 100

////  PARAMS
#define SPEED_MIN 1
#define SPEED_MAX 4300
#define SPEED_STEP 50

#define STEPS_MIN 0
#define STEPS_MAX 200000000  
#define STEPS_STEP 1000

#define ACC_MIN 0
#define ACC_MAX 50000
#define ACC_STEP 100

#define FRAME_COUNT_MIN 1
#define FRAME_COUNT_MAX 200
#define FRAME_COUNT_STEP 1

#define PAUSE_MIN 0
#define PAUSE_MAX 50000
#define PAUSE_STEP 100
#define PAUSE_NONE   0
#define PAUSE_BURST -1


#define NUM_PROGRAMS 4

#define CW -1  //clockwise
#define CCW 1  //counterclockwise

/////////Ir buttons map
#define BTN_POWER      24480         // pos 0 0 OK = power ????????
#define BTN_VOL_U      29835         // pos 0 1 OK = fleche haut -> changer de paramètre
#define BTN_FUNC       24097         // pos 0 2 OK = Setup

#define BTN_RW         22312         // pos 1 0 OK = fleche gauche -> changer de program
#define BTN_PLAY       30217         // pos 1 1 OK = OK -> lancer sequence ou selectionner menu
#define BTN_FW         22440         // pos 1 2 OK = fleche droite -> changer de program

#define BTN_CH_D       29580         // pos 2 0 OK = vol+ -> ?????????
#define BTN_VOL_D      29325         // pos 2 1 OK = fleche bas -> changer de paramètre
#define BTN_CH_U       29452         // pos 2 2 OK = back -> changer sens rotation en mode run


#define BTN_0          32512         // pos 3 0 OK
#define BTN_EQ         30472         // pos 3 1 OK = home -> reinit valeur ou run
#define BTN_ST         30600         // pos 3 2 OK = vol- -> ????????

#define BTN_1          22695         // pos 4 0 OK
#define BTN_2          30982         // pos 4 1 OK
#define BTN_3          31110         // pos 4 2 OK
#define BTN_4          23205         // pos 5 0 OK
#define BTN_5          31492         // pos 5 1 OK
#define BTN_6          31620         // pos 5 2 OK
#define BTN_7          23715         // pos 6 0 OK
#define BTN_8          32002         // pos 6 1 OK
#define BTN_9          32130         // pos 6 2 OK

///////// LCD buttons map
//???#define btnRIGHT  100
//???#define btnUP     101
//???#define btnDOWN   102
//???#define btnLEFT   103
//???#define btnSELECT 104
//???#define btnNONE   105

#endif
